const chalk = require('chalk')
const { copy } = require('fs-extra')
const { appConfig } = require('./config')

const copyFileToApp = ({ CURR_DIR, TARGET_PATH }) => {
  // copy files
  console.log(chalk.green(`🥳 Start generate file ...`))
  const packagePath = `${CURR_DIR}/node_modules/${appConfig.packageName}/source-code`
  copy(`${packagePath}/.husky`, `${TARGET_PATH}/.husky`)
  copy(`${packagePath}/.vscode`, `${TARGET_PATH}/.vscode`)
  copy(`${packagePath}/env`, `${TARGET_PATH}/public/env`)

  copy(
    `${packagePath}/src/components/BackgroundTasks`,
    `${TARGET_PATH}/src/components/BackgroundTasks`
  )
  copy(
    `${packagePath}/src/components/.keep`,
    `${TARGET_PATH}/src/components/.keep`
  )
  copy(`${packagePath}/src/environments`, `${TARGET_PATH}/src/environments`)
  copy(`${packagePath}/src/helper`, `${TARGET_PATH}/src/helper`)
  copy(`${packagePath}/src/hooks`, `${TARGET_PATH}/src/hooks`)
  copy(`${packagePath}/src/http`, `${TARGET_PATH}/src/http`)
  copy(`${packagePath}/src/layouts`, `${TARGET_PATH}/src/layouts`)
  copy(`${packagePath}/src/pages`, `${TARGET_PATH}/src/pages`)
  copy(`${packagePath}/src/redux`, `${TARGET_PATH}/src/redux`)
  copy(`${packagePath}/src/router`, `${TARGET_PATH}/src/router`)
  copy(`${packagePath}/src/services`, `${TARGET_PATH}/src/services`)

  copy(`${packagePath}/.editorconfig`, `${TARGET_PATH}/.editorconfig`)
  copy(`${packagePath}/.env.development`, `${TARGET_PATH}/.env.development`)
  copy(`${packagePath}/.env.production`, `${TARGET_PATH}/.env.production`)
  copy(`${packagePath}/.env.testing`, `${TARGET_PATH}/.env.testing`)
  copy(`${packagePath}/.env.uat`, `${TARGET_PATH}/.env.uat`)
  copy(`${packagePath}/.prettierignore`, `${TARGET_PATH}/.prettierignore`)
  copy(`${packagePath}/.prettierrc`, `${TARGET_PATH}/.prettierrc`)

  // replace src/index.tsx file
  copy(`${packagePath}/index.tsx`, `${TARGET_PATH}/index.tsx`)
  copy(`${packagePath}/App.tsx`, `${TARGET_PATH}/App.tsx`)
}
module.exports.copyFileToApp = copyFileToApp
